# File generated from our OpenAPI spec by Stainless. See CONTRIBUTING.md for details.

from __future__ import annotations

import os
from typing import Any, cast

import pytest

from Headless1 import Headless1, AsyncHeadless1
from tests.utils import assert_matches_type
from Headless1.types import CallAgentCallAgentResponse

base_url = os.environ.get("TEST_API_BASE_URL", "http://127.0.0.1:4010")


class TestCallAgent:
    parametrize = pytest.mark.parametrize("client", [False, True], indirect=True, ids=["loose", "strict"])

    @pytest.mark.skip()
    @parametrize
    def test_method_call_agent(self, client: Headless1) -> None:
        call_agent = client.call_agent.call_agent(
            agent_id="ag_123456789",
        )
        assert_matches_type(CallAgentCallAgentResponse, call_agent, path=["response"])

    @pytest.mark.skip()
    @parametrize
    def test_method_call_agent_with_all_params(self, client: Headless1) -> None:
        call_agent = client.call_agent.call_agent(
            agent_id="ag_123456789",
            conversation_id="conv_456def",
            request="What are your best-selling products?",
        )
        assert_matches_type(CallAgentCallAgentResponse, call_agent, path=["response"])

    @pytest.mark.skip()
    @parametrize
    def test_raw_response_call_agent(self, client: Headless1) -> None:
        response = client.call_agent.with_raw_response.call_agent(
            agent_id="ag_123456789",
        )

        assert response.is_closed is True
        assert response.http_request.headers.get("X-Stainless-Lang") == "python"
        call_agent = response.parse()
        assert_matches_type(CallAgentCallAgentResponse, call_agent, path=["response"])

    @pytest.mark.skip()
    @parametrize
    def test_streaming_response_call_agent(self, client: Headless1) -> None:
        with client.call_agent.with_streaming_response.call_agent(
            agent_id="ag_123456789",
        ) as response:
            assert not response.is_closed
            assert response.http_request.headers.get("X-Stainless-Lang") == "python"

            call_agent = response.parse()
            assert_matches_type(CallAgentCallAgentResponse, call_agent, path=["response"])

        assert cast(Any, response.is_closed) is True

    @pytest.mark.skip()
    @parametrize
    def test_path_params_call_agent(self, client: Headless1) -> None:
        with pytest.raises(ValueError, match=r"Expected a non-empty value for `agent_id` but received ''"):
            client.call_agent.with_raw_response.call_agent(
                agent_id="",
            )


class TestAsyncCallAgent:
    parametrize = pytest.mark.parametrize("async_client", [False, True], indirect=True, ids=["loose", "strict"])

    @pytest.mark.skip()
    @parametrize
    async def test_method_call_agent(self, async_client: AsyncHeadless1) -> None:
        call_agent = await async_client.call_agent.call_agent(
            agent_id="ag_123456789",
        )
        assert_matches_type(CallAgentCallAgentResponse, call_agent, path=["response"])

    @pytest.mark.skip()
    @parametrize
    async def test_method_call_agent_with_all_params(self, async_client: AsyncHeadless1) -> None:
        call_agent = await async_client.call_agent.call_agent(
            agent_id="ag_123456789",
            conversation_id="conv_456def",
            request="What are your best-selling products?",
        )
        assert_matches_type(CallAgentCallAgentResponse, call_agent, path=["response"])

    @pytest.mark.skip()
    @parametrize
    async def test_raw_response_call_agent(self, async_client: AsyncHeadless1) -> None:
        response = await async_client.call_agent.with_raw_response.call_agent(
            agent_id="ag_123456789",
        )

        assert response.is_closed is True
        assert response.http_request.headers.get("X-Stainless-Lang") == "python"
        call_agent = await response.parse()
        assert_matches_type(CallAgentCallAgentResponse, call_agent, path=["response"])

    @pytest.mark.skip()
    @parametrize
    async def test_streaming_response_call_agent(self, async_client: AsyncHeadless1) -> None:
        async with async_client.call_agent.with_streaming_response.call_agent(
            agent_id="ag_123456789",
        ) as response:
            assert not response.is_closed
            assert response.http_request.headers.get("X-Stainless-Lang") == "python"

            call_agent = await response.parse()
            assert_matches_type(CallAgentCallAgentResponse, call_agent, path=["response"])

        assert cast(Any, response.is_closed) is True

    @pytest.mark.skip()
    @parametrize
    async def test_path_params_call_agent(self, async_client: AsyncHeadless1) -> None:
        with pytest.raises(ValueError, match=r"Expected a non-empty value for `agent_id` but received ''"):
            await async_client.call_agent.with_raw_response.call_agent(
                agent_id="",
            )
