# File generated from our OpenAPI spec by Stainless. See CONTRIBUTING.md for details.

from __future__ import annotations

import os
from typing import Any, cast

import pytest

from Headless1 import Headless1, AsyncHeadless1
from tests.utils import assert_matches_type
from Headless1.types import CreateSchemaCreateSchemaResponse

base_url = os.environ.get("TEST_API_BASE_URL", "http://127.0.0.1:4010")


class TestCreateSchema:
    parametrize = pytest.mark.parametrize("client", [False, True], indirect=True, ids=["loose", "strict"])

    @pytest.mark.skip()
    @parametrize
    def test_method_create_schema(self, client: Headless1) -> None:
        create_schema = client.create_schema.create_schema(
            prompt="Create a schema for a customer support ticket",
        )
        assert_matches_type(CreateSchemaCreateSchemaResponse, create_schema, path=["response"])

    @pytest.mark.skip()
    @parametrize
    def test_method_create_schema_with_all_params(self, client: Headless1) -> None:
        create_schema = client.create_schema.create_schema(
            prompt="Create a schema for a customer support ticket",
            conversation_id="conv_123abc",
        )
        assert_matches_type(CreateSchemaCreateSchemaResponse, create_schema, path=["response"])

    @pytest.mark.skip()
    @parametrize
    def test_raw_response_create_schema(self, client: Headless1) -> None:
        response = client.create_schema.with_raw_response.create_schema(
            prompt="Create a schema for a customer support ticket",
        )

        assert response.is_closed is True
        assert response.http_request.headers.get("X-Stainless-Lang") == "python"
        create_schema = response.parse()
        assert_matches_type(CreateSchemaCreateSchemaResponse, create_schema, path=["response"])

    @pytest.mark.skip()
    @parametrize
    def test_streaming_response_create_schema(self, client: Headless1) -> None:
        with client.create_schema.with_streaming_response.create_schema(
            prompt="Create a schema for a customer support ticket",
        ) as response:
            assert not response.is_closed
            assert response.http_request.headers.get("X-Stainless-Lang") == "python"

            create_schema = response.parse()
            assert_matches_type(CreateSchemaCreateSchemaResponse, create_schema, path=["response"])

        assert cast(Any, response.is_closed) is True


class TestAsyncCreateSchema:
    parametrize = pytest.mark.parametrize("async_client", [False, True], indirect=True, ids=["loose", "strict"])

    @pytest.mark.skip()
    @parametrize
    async def test_method_create_schema(self, async_client: AsyncHeadless1) -> None:
        create_schema = await async_client.create_schema.create_schema(
            prompt="Create a schema for a customer support ticket",
        )
        assert_matches_type(CreateSchemaCreateSchemaResponse, create_schema, path=["response"])

    @pytest.mark.skip()
    @parametrize
    async def test_method_create_schema_with_all_params(self, async_client: AsyncHeadless1) -> None:
        create_schema = await async_client.create_schema.create_schema(
            prompt="Create a schema for a customer support ticket",
            conversation_id="conv_123abc",
        )
        assert_matches_type(CreateSchemaCreateSchemaResponse, create_schema, path=["response"])

    @pytest.mark.skip()
    @parametrize
    async def test_raw_response_create_schema(self, async_client: AsyncHeadless1) -> None:
        response = await async_client.create_schema.with_raw_response.create_schema(
            prompt="Create a schema for a customer support ticket",
        )

        assert response.is_closed is True
        assert response.http_request.headers.get("X-Stainless-Lang") == "python"
        create_schema = await response.parse()
        assert_matches_type(CreateSchemaCreateSchemaResponse, create_schema, path=["response"])

    @pytest.mark.skip()
    @parametrize
    async def test_streaming_response_create_schema(self, async_client: AsyncHeadless1) -> None:
        async with async_client.create_schema.with_streaming_response.create_schema(
            prompt="Create a schema for a customer support ticket",
        ) as response:
            assert not response.is_closed
            assert response.http_request.headers.get("X-Stainless-Lang") == "python"

            create_schema = await response.parse()
            assert_matches_type(CreateSchemaCreateSchemaResponse, create_schema, path=["response"])

        assert cast(Any, response.is_closed) is True
