# File generated from our OpenAPI spec by Stainless. See CONTRIBUTING.md for details.

from __future__ import annotations

import os
from typing import Any, cast

import pytest

from Headless1 import Headless1, AsyncHeadless1
from tests.utils import assert_matches_type
from Headless1.types import HealthCheckHealthCheckResponse

base_url = os.environ.get("TEST_API_BASE_URL", "http://127.0.0.1:4010")


class TestHealthCheck:
    parametrize = pytest.mark.parametrize("client", [False, True], indirect=True, ids=["loose", "strict"])

    @pytest.mark.skip()
    @parametrize
    def test_method_health_check(self, client: Headless1) -> None:
        health_check = client.health_check.health_check()
        assert_matches_type(HealthCheckHealthCheckResponse, health_check, path=["response"])

    @pytest.mark.skip()
    @parametrize
    def test_raw_response_health_check(self, client: Headless1) -> None:
        response = client.health_check.with_raw_response.health_check()

        assert response.is_closed is True
        assert response.http_request.headers.get("X-Stainless-Lang") == "python"
        health_check = response.parse()
        assert_matches_type(HealthCheckHealthCheckResponse, health_check, path=["response"])

    @pytest.mark.skip()
    @parametrize
    def test_streaming_response_health_check(self, client: Headless1) -> None:
        with client.health_check.with_streaming_response.health_check() as response:
            assert not response.is_closed
            assert response.http_request.headers.get("X-Stainless-Lang") == "python"

            health_check = response.parse()
            assert_matches_type(HealthCheckHealthCheckResponse, health_check, path=["response"])

        assert cast(Any, response.is_closed) is True


class TestAsyncHealthCheck:
    parametrize = pytest.mark.parametrize("async_client", [False, True], indirect=True, ids=["loose", "strict"])

    @pytest.mark.skip()
    @parametrize
    async def test_method_health_check(self, async_client: AsyncHeadless1) -> None:
        health_check = await async_client.health_check.health_check()
        assert_matches_type(HealthCheckHealthCheckResponse, health_check, path=["response"])

    @pytest.mark.skip()
    @parametrize
    async def test_raw_response_health_check(self, async_client: AsyncHeadless1) -> None:
        response = await async_client.health_check.with_raw_response.health_check()

        assert response.is_closed is True
        assert response.http_request.headers.get("X-Stainless-Lang") == "python"
        health_check = await response.parse()
        assert_matches_type(HealthCheckHealthCheckResponse, health_check, path=["response"])

    @pytest.mark.skip()
    @parametrize
    async def test_streaming_response_health_check(self, async_client: AsyncHeadless1) -> None:
        async with async_client.health_check.with_streaming_response.health_check() as response:
            assert not response.is_closed
            assert response.http_request.headers.get("X-Stainless-Lang") == "python"

            health_check = await response.parse()
            assert_matches_type(HealthCheckHealthCheckResponse, health_check, path=["response"])

        assert cast(Any, response.is_closed) is True
