# File generated from our OpenAPI spec by Stainless. See CONTRIBUTING.md for details.

from __future__ import annotations

import os
from typing import Any, cast

import pytest

from Headless1 import Headless1, AsyncHeadless1
from tests.utils import assert_matches_type
from Headless1.types import ProcessObjectiveProcessObjectiveResponse

base_url = os.environ.get("TEST_API_BASE_URL", "http://127.0.0.1:4010")


class TestProcessObjective:
    parametrize = pytest.mark.parametrize("client", [False, True], indirect=True, ids=["loose", "strict"])

    @pytest.mark.skip()
    @parametrize
    def test_method_process_objective(self, client: Headless1) -> None:
        process_objective = client.process_objective.process_objective(
            agent_ids=["ag_123456789", "ag_987654321"],
            user_objective="I need help with product selection and technical setup",
        )
        assert_matches_type(ProcessObjectiveProcessObjectiveResponse, process_objective, path=["response"])

    @pytest.mark.skip()
    @parametrize
    def test_method_process_objective_with_all_params(self, client: Headless1) -> None:
        process_objective = client.process_objective.process_objective(
            agent_ids=["ag_123456789", "ag_987654321"],
            user_objective="I need help with product selection and technical setup",
            conversation_id="conv_789ghi",
        )
        assert_matches_type(ProcessObjectiveProcessObjectiveResponse, process_objective, path=["response"])

    @pytest.mark.skip()
    @parametrize
    def test_raw_response_process_objective(self, client: Headless1) -> None:
        response = client.process_objective.with_raw_response.process_objective(
            agent_ids=["ag_123456789", "ag_987654321"],
            user_objective="I need help with product selection and technical setup",
        )

        assert response.is_closed is True
        assert response.http_request.headers.get("X-Stainless-Lang") == "python"
        process_objective = response.parse()
        assert_matches_type(ProcessObjectiveProcessObjectiveResponse, process_objective, path=["response"])

    @pytest.mark.skip()
    @parametrize
    def test_streaming_response_process_objective(self, client: Headless1) -> None:
        with client.process_objective.with_streaming_response.process_objective(
            agent_ids=["ag_123456789", "ag_987654321"],
            user_objective="I need help with product selection and technical setup",
        ) as response:
            assert not response.is_closed
            assert response.http_request.headers.get("X-Stainless-Lang") == "python"

            process_objective = response.parse()
            assert_matches_type(ProcessObjectiveProcessObjectiveResponse, process_objective, path=["response"])

        assert cast(Any, response.is_closed) is True


class TestAsyncProcessObjective:
    parametrize = pytest.mark.parametrize("async_client", [False, True], indirect=True, ids=["loose", "strict"])

    @pytest.mark.skip()
    @parametrize
    async def test_method_process_objective(self, async_client: AsyncHeadless1) -> None:
        process_objective = await async_client.process_objective.process_objective(
            agent_ids=["ag_123456789", "ag_987654321"],
            user_objective="I need help with product selection and technical setup",
        )
        assert_matches_type(ProcessObjectiveProcessObjectiveResponse, process_objective, path=["response"])

    @pytest.mark.skip()
    @parametrize
    async def test_method_process_objective_with_all_params(self, async_client: AsyncHeadless1) -> None:
        process_objective = await async_client.process_objective.process_objective(
            agent_ids=["ag_123456789", "ag_987654321"],
            user_objective="I need help with product selection and technical setup",
            conversation_id="conv_789ghi",
        )
        assert_matches_type(ProcessObjectiveProcessObjectiveResponse, process_objective, path=["response"])

    @pytest.mark.skip()
    @parametrize
    async def test_raw_response_process_objective(self, async_client: AsyncHeadless1) -> None:
        response = await async_client.process_objective.with_raw_response.process_objective(
            agent_ids=["ag_123456789", "ag_987654321"],
            user_objective="I need help with product selection and technical setup",
        )

        assert response.is_closed is True
        assert response.http_request.headers.get("X-Stainless-Lang") == "python"
        process_objective = await response.parse()
        assert_matches_type(ProcessObjectiveProcessObjectiveResponse, process_objective, path=["response"])

    @pytest.mark.skip()
    @parametrize
    async def test_streaming_response_process_objective(self, async_client: AsyncHeadless1) -> None:
        async with async_client.process_objective.with_streaming_response.process_objective(
            agent_ids=["ag_123456789", "ag_987654321"],
            user_objective="I need help with product selection and technical setup",
        ) as response:
            assert not response.is_closed
            assert response.http_request.headers.get("X-Stainless-Lang") == "python"

            process_objective = await response.parse()
            assert_matches_type(ProcessObjectiveProcessObjectiveResponse, process_objective, path=["response"])

        assert cast(Any, response.is_closed) is True
